/*
 * RealEstate in Flash with PHP
 * by PhilFlash - http://philflash.inway.fr
 *
 * Initial version in ColdFusion. See:
 *  - The Real Estate Sample Application - Part 1: Building the Search Functionality with Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms.html
 *  - The Real Estate Sample Application - Part 2: Managing Property Listings Through Flash Forms
 *    http://www.macromedia.com/devnet/coldfusion/articles/flashforms_pt2.html
 *
 * More information. See AsFusion Blog:
 *  - http://www.asfusion.com/blog/entry/coldfusion-flash-forms-macromedia-2
 * 
 */

import mx.utils.Delegate;
import mx.controls.Alert;
import mx.styles.CSSStyleDeclaration;
import mx.controls.ProgressBar;
	
import mx.controls.Button;
import mx.data.components.XMLConnector;


class form.ApplicationForm extends mx.screens.Form {
	public var onServer:Boolean = false;
	public var siteURL:String;
	
	public var state_con:XMLConnector;
	public var stateArray:Array;
	
	private var pBar:ProgressBar;
	
	// Constructor
	public function ApplicationForm() {}
	
	// -----   ----- 
	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);
		
		_global.style.setStyle("fontFamily" , "Verdana");
		_global.style.setStyle("fontSize",10);
		_global.style.setStyle("fontWeight", "normal");	
		
		_global.style.setStyle("themeColor", 0x9CD1FE); 
		_global.style.setStyle("textSelectedColor", 0x333333);
		_global.style.setStyle("rollOverColor", 0xD4E7F7);
		
		// -- form -- 
		var styleObj:CSSStyleDeclaration;
		styleObj = new mx.styles.CSSStyleDeclaration();
		styleObj.styleName = "h1";
		styleObj.fontFamily = "Verdana";
		styleObj.fontSize = 10;
		styleObj.fontWeight = "bold";
		styleObj.color = 0xFFFFFF;
		_global.styles["h1"] = styleObj;
		
		styleObj = new mx.styles.CSSStyleDeclaration();
		styleObj.styleName = "label";
		styleObj.fontFamily = "Verdana";
		styleObj.fontSize = 10;
		styleObj.fontWeight = "bold";
		styleObj.color = 0x222222;
		_global.styles["label"] = styleObj;
		
		// -- for edit -- 
		styleObj = new mx.styles.CSSStyleDeclaration();
		styleObj.styleName = "labelStyle";
		styleObj.fontFamily = "Verdana";
		styleObj.fontSize = 10;
		styleObj.fontWeight = "normal";
		styleObj.color = 0x000000;
		_global.styles["labelStyle"] = styleObj;
		
		styleObj = new mx.styles.CSSStyleDeclaration();
		styleObj.styleName = "labelStyleError";
		styleObj.fontFamily = "Verdana";
		styleObj.fontSize = 10;
		styleObj.fontWeight = "bold";
		styleObj.color = 0xFF0000;
		_global.styles["labelStyleError"] = styleObj;
		
	}

	// -----   ----- 	
	public function onLoad(obj:Object):Void {
		setVisible(true);
		// -- --
		Stage.showMenu = false;
		// -- --
		pBar.setVisible(false, true);
		// -- On modifie les URL --
    	if (_url.substr(0, 7) == "http://") {
			onServer = true; 
			siteURL = "";
		} else {
			onServer = false;
			siteURL= "http://localhost/realestatep2/";
		}
		(rootForm).search.listing_con.URL = siteURL+"selectlisting.php";
		(rootForm).main.operation_con.URL = siteURL+"operation.php";
		state_con.URL = siteURL+"getstate.php";
		//
		state_con.addEventListener("result", Delegate.create(this, doResultStateAction));
		state_con.trigger();
	}

	// -----   ----- 	
	public function onReveal(obj:Object):Void {
	}

	// -----  -----
	function enableProgress(enabled:Boolean, label:String):Void {
		var waiting = (rootForm).waiting;
		//
		waiting.setVisible(enabled);
		//
		var progressBar = waiting.pBar;
		progressBar.label = (label == undefined ? "" : label);
		progressBar.indeterminate = progressBar.enabled = progressBar._visible = enabled;
		// 
		(rootForm).main.listing_dg.enabled = !enabled;
	}
	
	public function doResultStateAction():Void {
		// get result
		var resultXML:XML = state_con.results;		
		var rootNode = resultXML.firstChild;
		
		stateArray = [];
			
		// parse XML
		var aNode:XMLNode = rootNode.firstChild;
		while (aNode) {
			var obj = new Object();
			for (var attribute:String in aNode.attributes) {
				obj[attribute] = aNode.attributes[attribute];	
			}
			stateArray.push(obj);
			aNode = aNode.nextSibling;
		}
		//trace("doResultStateAction ="+ stateArray.length);
		state_con.dispatchEvent({type:"stateComplete", data:stateArray});
	}		

	// -----  -----
	function setLocationRelativeTo(mc:MovieClip, mcowner:Object) {
		var x0:Number = 0;
		var y0:Number = 0;
		if (mcowner != undefined && mcowner instanceof MovieClip) {
			x0 = mcowner._x+(mcowner._width/2);
			y0 = mcowner._y+(mcowner._height/2);	
			var x:Number = x0 - mc._width/2;
			var y:Number = y0 - mc._height/2;

			var point:Object = {x:x, y:y};
			mcowner._parent.localToGlobal(point);
			x = point.x;
			y = point.y;

			if (x < 0) {
				x = 0;
			}
			if (y < 0) {
				y = 0;
			}
			if (x + mc._width > Stage.width) {
				x = Stage.width - mc._width;
			}
			if (y + mc._height > Stage.height) {
				y = Stage.height - mc.height;
			}
			mc.move(x,y);	
		} else {
			mc.move((Stage.width-mc._width)/2, (Stage.height-mc._height)/2);	
		}
	}

}
    

